#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum SearchModulesSortField {
    #[serde(rename = "NAME")]
    Name,
    #[serde(rename = "LAST_UPDATED_AT")]
    LastUpdatedAt,
    #[serde(rename = "CREATED_AT")]
    CreatedAt,
    #[serde(rename = "ARCHIVED_AT")]
    ArchivedAt,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl SearchModulesSortField {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            SearchModulesSortField::Name => "NAME",
            SearchModulesSortField::LastUpdatedAt => "LAST_UPDATED_AT",
            SearchModulesSortField::CreatedAt => "CREATED_AT",
            SearchModulesSortField::ArchivedAt => "ARCHIVED_AT",
            SearchModulesSortField::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for SearchModulesSortField {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for SearchModulesSortField {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for SearchModulesSortField {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<SearchModulesSortField, conjure_object::plain::ParseEnumError> {
        match v {
            "NAME" => Ok(SearchModulesSortField::Name),
            "LAST_UPDATED_AT" => Ok(SearchModulesSortField::LastUpdatedAt),
            "CREATED_AT" => Ok(SearchModulesSortField::CreatedAt),
            "ARCHIVED_AT" => Ok(SearchModulesSortField::ArchivedAt),
            v => v.parse().map(|v| SearchModulesSortField::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for SearchModulesSortField {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<SearchModulesSortField, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the SearchModulesSortField enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
